/*
 * Can I come up with a lock-free implementation that is the
 * same for pthread and BGQ? Need N+1
 */
#include <bfm.h>

void ThreadModelPthread::thread_init      (int nthr) 
{
  nthread = nthr;
  barrier_threads = nthread;
  pthread_mutex_init(&barrier_lock,NULL);
  sum_array = (double *)malloc(nthr*sizeof(double)); // Missing free
}

int  ThreadModelPthread::thread_barrier(void) 
{

  int me;
  int mystep;

  int err = pthread_mutex_lock(&barrier_lock);

    if (err ) {
      perror("lock failed");
      exit(0);
    }
    mystep = barrier_step;
    me     = barrier_threads = barrier_threads-1; 

    if ( me == 0 ) {
      barrier_threads = nthread;
      barrier_step++;
    }
    

  err = pthread_mutex_unlock(&barrier_lock);
  if (err ) {
    perror("lock failed");
    exit(0);

  }

  int bs;
  do { 
    pthread_mutex_lock(&barrier_lock);
    bs = barrier_step;
    pthread_mutex_unlock(&barrier_lock);
  } while(bs == mystep);

  return me;

}

/*This could be shared*/
void ThreadModelPthread::thread_sum    (double &val,int me) 
{
  thread_barrier();
  sum_array[me] = val;
  thread_barrier();
  val=0;
  for(int i=0;i<nthread;i++) val+= sum_array[i];
  thread_barrier();
}

void ThreadModelSPI::thread_csum    (uint64_t &val,int me) 
{
  uint64_t *csum_array = (uint64_t *)sum_array;
  csum_array[me] = val;
  val=0;
  thread_barrier();
  for(int i=0;i<nthread;i++) val^= csum_array[i];
  thread_barrier();
}

void  *ThreadModelPthread::thread_bcast(int me,void * val) 
{ 
  if (me == 0) bcast_ptr = val;
  thread_barrier();
  val = bcast_ptr;
  thread_barrier();
  return val; 
};
