#ifndef KRY5D_H
#define KRY5D_H

#include "Krylov.h"
#include <cstdlib>
#include <string>
#include <cmath>
#include <iostream>
#include <sstream>
#include <stdexcept>
#include <fstream>
#include <complex>

/** 5d inner product **/
/*Complex Inner_5d(multi1d<LatticeFermion> a, multi1d<LatticeFermion> b){

	Complex sum = 0;
	int Ls = a.size();
	for(int s=0;s<Ls;s++){
		sum = sum + innerProduct(a[s],b[s]);
	}
	return sum;

}

Complex Inner_5d(vector<LatticeFermion> a, vector<LatticeFermion> b){

	Complex sum = 0;
	int Ls = a.size();
	for(int s=0;s<Ls;s++){
		sum = sum + innerProduct(a[s],b[s]);
	}
	return sum;

}
*/
/** 5d norm **/
/*Real Norm_5d(multi1d<LatticeFermion> a){

	Real sum = 0;
	int Ls = a.size();
	for(int s=0;s<Ls;s++){
		sum = sum + norm2(a[s]);
	}
	return sqrt(sum);

}

Real Norm_5d(vector<LatticeFermion> a){

	Real sum = 0;
	int Ls = a.size();
	for(int s=0;s<Ls;s++){
		sum = sum + norm2(a[s]);
	}
	return sqrt(sum);

}
*/
/** r is orthagonal to the first N vectors in q **/
/*void Gram(multi1d<LatticeFermion> &r, multi1d<multi1d<LatticeFermion> > q, int N){

int Ls = r.size();
for(int i=0;i<N;i++){
	for(int s=0;s<Ls;s++){
		r[s] = r[s]   -  ( Inner_5d(q[i],r)/Inner_5d(q[i],q[i]) )*q[i][s];}
	}

}
*/
/** q is orthonormal **/
/*void Gram(multi1d<multi1d<LatticeFermion> > &q){

int Ls = q[0].size();
int M = q.size();

for(int j=0;j<M;j++){
for(int i=0;i<j;i++){
		Complex coeff = ( Inner_5d(q[i],q[j])/Inner_5d(q[i],q[i]) );
		for(int s=0;s<Ls;s++){q[j][s] = q[j][s]   -  coeff*q[i][s];}
	}
	}
	
for(int j=0;j<M;j++){
		Real norm = Norm_5d(q[j]);
		for(int s=0;s<Ls;s++){q[j][s] = q[j][s]*(1.0/norm );}
}


}
*/
/** q is orthonormal **/
/*void Gram(vector<multi1d<LatticeFermion> > &q){

int Ls = q[0].size();
int M = q.size();

for(int j=0;j<M;j++){
for(int i=0;i<j;i++){
		Complex coeff = ( Inner_5d(q[i],q[j])/Inner_5d(q[i],q[i]) );
		for(int s=0;s<Ls;s++){q[j][s] = q[j][s]   -  coeff*q[i][s];}
	}
	}
	
for(int j=0;j<M;j++){
		Real norm = Norm_5d(q[j]);
		for(int s=0;s<Ls;s++){q[j][s] = q[j][s]*(1.0/norm );}
}	


}
*/
/*
template <class T> void times(multi1d<multi1d<LatticeFermion> > &q, Matrix<complex<T> > &Q){
	multi1d<multi1d<LatticeFermion> > S( q.size() );
	int Ls = q[0].size();
	for(int j=0;j<q.size();j++){
		S[j].resize(Ls); for(int s=0;s<Ls;s++){S[j][s] = zero;}
		for(int k=0;k<q.size();k++){
			for(int s=0;s<Ls;s++){
				S[j][s] = S[j][s] + q[k][s] * toComplex<T>( Q(k,j) ); 
			}
		}
	}
	for(int s=0;s<Ls;s++){
		for(int j=0;j<q.size();j++){q[j][s] = S[j][s];}
	}
}
*/

template <class S> class Krylov_5d : public Krylov<S>{

  public:

  bfm_qdp<double> dop5d;
  Krylov_5d(bfm_qdp<S> &dwf) : Krylov<S>(dwf){}
 ~Krylov_5d(){dop5d.end();}
  void eigs_to_qdp( multi1d<multi1d<LatticeFermion> > &con_vecs, multi1d<Complex> &con_vals );

  protected:

  void init();
  virtual void dwf_multiply(bfm_fermion input, bfm_fermion &result);
  void dwf_multiply(bfm_fermion input, bfm_fermion &result, bool dag);
  virtual void herm_mult(bfm_fermion input, bfm_fermion &result);

};


template <class S> void Krylov_5d<S>::init(){
  
    if(!this->initialized){
    QDPIO::cout << "initializing" << endl;
    this->Krylov_init();
    if(this->D == G5D && this->dwfa.solver == DWF && this->prec == 1){
      QDPIO::cerr << "5d preconditioned gamma5 D operator is not Hermitian. " << endl;
      exit(0);
    }
    ///5d initialize
    if(this->dwfa.solver == DWFrb4d){this->prectype = 0;}
    if(this->dwfa.solver == DWF){this->prectype = 1;}
    this->dwfa.precon_5d = this->prectype;
    this->dwfa.Ls = this->Ls;

    this->dop.init(this->dwfa);
    this->init_fermion(this->tmp1); 
    this->init_fermion(this->tmp2);

    this->dop5d.init(this->dwfa);
    this->dop5d.importGauge(this->u);

#pragma omp parallel 
  {
    omp_set_num_threads(dop5d.nthread);
#pragma omp for 
    for(int i=0;i<dop5d.nthread;i++) {
    this->tmp = this->dop5d.threadedAllocFermion();
}}

    this->bq.resize(this->M); for(int i=0;i<this->M;i++){this->init_fermion(this->bq[i]);}QDPIO::cout << "here3" << endl;
    int sizebf;
    if(this->kr == lan){sizebf = 1;}
    //else if(this->kr == arn){sizebf = this->M;}
    this->bf.resize(sizebf); 
	for(int i=0; i< sizebf; i++){
        	this->init_fermion(this->bf[i]);
		this->zero_fermion(this->bf[i]);
	}
    multi1d<LatticeFermion> st(this->Ls);
    Fermion of = zero;
    SpinVector tspin = zero;
    Complex cno = cmplx(Real(1),Real(0));
    for(int spn=0;spn<Nd;spn++) pokeSpin(tspin, cno, spn);
    for(int col=0;col<Nd;col++) pokeColor(of, tspin, col);

    //for(int k = 0; k<this->Ls; k++){gaussian(st[k]);}
    st[0] = of; st[this->Ls-1] = of; 
    for(int k = 1; k<this->Ls-1; k++){
      st[k] = zero;
    }
    this->qdp_to_bfm(st,this->bq[0]);
    double hnorm = this->norm(this->bq[0]);
    this->axpby(this->bq[0],0,this->bq[0],1.0/hnorm,this->bq[0]);

    this->initialized=true;
    }
}

template <class S> void Krylov_5d<S>::eigs_to_qdp( multi1d<multi1d<LatticeFermion> > &con_vecs, multi1d<Complex> &con_vals ){

	int Nev = this->evals.size();
	con_vecs.resize(Nev); for(int i = 0; i<Nev; i++){con_vecs[i].resize(this->Ls);}
	con_vals.resize(Nev);
	for(int i = 0; i<Nev; i++){
		con_vals[i] = this->evals[i];
		this->bfm_to_qdp(this->bq[i], con_vecs[i]);
	}
}

template <class S> void Krylov_5d<S>::dwf_multiply(bfm_fermion input, bfm_fermion &result){
  
  bool dag = false;
  if(this->D == DDAG){dag = true;}
#pragma omp parallel 
  {
    omp_set_num_threads(dop5d.nthread);
#pragma omp for 
    for(int i=0;i<dop5d.nthread;i++) {
  if(this->prec == 1){
    dop5d.Mprec( input[1], result[1], this->tmp, dag, 0) ;
  }
  else {
    dop5d.Munprec( input, result, this->tmp, dag) ;
  }
  }}
}

template <class S> void Krylov_5d<S>::dwf_multiply(bfm_fermion input, bfm_fermion &result, bool dag){
#pragma omp parallel 
  {
    omp_set_num_threads(dop5d.nthread);
#pragma omp for 
    for(int i=0;i<dop5d.nthread;i++) {
  if(this->prec == 1){
    dop5d.Mprec( input[1], result[1], this->tmp, dag, 0) ;
  }
  else {
    dop5d.Munprec( input, result, this->tmp, dag) ;
  }
  }}
}

template <class S> void Krylov_5d<S>::herm_mult(bfm_fermion input, bfm_fermion &result){

  if(this->D == G5D){
    dwf_multiply(input,result,false);  this->mvprod++;  //D
    this->axpy(this->tmp1 , 0.0, result, result);
    G5R(result, this->tmp1);
  } else if(this->D == DDAGD){
    dwf_multiply(input,this->tmp1,false);
    dwf_multiply(this->tmp1,result,true);    this->mvprod+=2;
  }
  else{
    QDPIO::cerr << "Don't know what to do with that operator" << endl;
  }
}

template <class T> class Lanczos_5d : public Krylov_5d<T>{
public:

Lanczos_5d(bfm_qdp<T> &dwf) : Krylov_5d<T>(dwf){this->kr = lan;}
void Initial_State(multi1d< multi1d<LatticeFermion> > Eigs, multi1d<Complex> val){

		this->init();
		if(this->cont){
			QDPIO::cout << "Lanczos5d: continue " << Eigs.size() << endl;
			for(int i=0;i<Eigs.size();i++){
				this->qdp_to_bfm(Eigs[i],this->bq[i]); 
				this->H( this->Chebyshev( toDouble(real(val[i]) )) , i, i);	
			}
			std::vector<double> tevals(Eigs.size());
        		std::vector<std::vector<double> > tevecs(Eigs.size());
			this->TestConv(Eigs.size(), tevals, tevecs);

			multi1d<LatticeFermion> tmp(this->Ls);
			for(int s = 0; s< this->Ls; s++){gaussian(tmp[s]);}
			this->qdp_to_bfm(tmp, this->bf[0]);
			this->Gram(this->bf[0],this->bq,Eigs.size());
		} 
		else if(this->refine){
			QDPIO::cout << "Lanczos5d: refining " << endl;
			multi1d<LatticeFermion> gg(this->Ls);
			for(int s = 0; s< this->Ls; s++) gg[s] = Eigs[0][s];
	
			for(int i=1;i<Eigs.size();i++){
				for(int s = 0; s< this->Ls; s++) gg[s] = gg[s] + Eigs[i][s]; 
			}

			Real nm = 0.0; for(int s = 0; s< this->Ls; s++) nm += norm2(gg[s]);
			nm = sqrt(nm); nm = 1.0/nm;
			for(int s = 0; s< this->Ls; s++) gg[s] = nm*gg[s];
			this->qdp_to_bfm(gg,this->bf[0]); 
		}
}

};





/**
An Arnoldi eigensolver.
**/
/*
template <class T> class Arnoldi_5d : public Krylov_5d<complex<T>, T, complex<double> >{
public:



Arnoldi_5d(bfm_qdp<T> dwf, EigenDescr Ed, eigentype c, 
multi1d<LatticeColorMatrix> UU,  multi1d< multi1d<LatticeFermion> > Eigs,
multi1d<Complex> val) : Krylov_5d<complex<T>, T, complex<double> >(dwf, Ed, c, UU, Eigs, val){
  	
        this->kr = arn;
	this->bf.resize(this->M); for(int i=0;i<this->M;i++)this->init_fermion(this->bf[i]);

}


};
*/

#endif


